#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MOD = 1e9 + 7;
const int BIG_SIZE = 5001;

pair<int, int> dp[BIG_SIZE][BIG_SIZE];
pair<int, int> prefSum[2 * BIG_SIZE][BIG_SIZE];

void makeDp(){
    for (int i = 0; i < BIG_SIZE; ++i){
        for (int j = 1; j < BIG_SIZE; ++j){
            prefSum[i][j].first = (prefSum[i][j - 1].first + prefSum[i][j].first) % MOD;
            prefSum[i][j].second = (prefSum[i][j - 1].second + prefSum[i][j].second) % MOD;
        }
        for (int j = 1; j < BIG_SIZE; ++j){
            if (i == 0){
                dp[i][j] = make_pair(1, 1);
                prefSum[i + j][j] = make_pair(1, 1);
                continue;
            }
            dp[i][j].first = prefSum[i][min(i, j - 1)].second;
            if (j <= i){
                dp[i][j].second = (prefSum[i][i].first - prefSum[i][j].first + MOD) % MOD;
            }
            prefSum[i + j][j].first = dp[i][j].first;
            prefSum[i + j][j].second = dp[i][j].second;
        }
    }
}

int main(){
    makeDp();
    int n, t;
    cin >> n >> t;
    if (n == t){
        cout << 1 << endl;
        return 0;
    }
    cout << (dp[n - t][t].first + dp[n - t][t].second) % MOD << endl;

    return 0;
}
