#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

bool check(vector<vector<int> > &g, int mask){
    for (int i = 0; i < g.size(); ++i){
        for (int j = 0; j < g[i].size(); ++j){
            if ((mask & (1 << i)) && (mask & (1 << g[i][j]))){
                return false;
            }
        }
    }
    return true;
}

int f(int mask){
    int ans = 0;
    while (mask > 0){
        ans += mask % 2;
        mask /= 2;
    }
    return ans;
}

void dfs(vector<vector<int> > &g, vector<char> &used, vector<pair<int, int> > &dp, int v){
    used[v] = true;
    int ans1 = 1, ans2 = 0;
    for (int i = 0; i < g[v].size(); ++i){
        int u = g[v][i];
        if (!used[u]){
            dfs(g, used, dp, u);
            ans1 += dp[u].second;
            ans2 += max(dp[u].first, dp[u].second);
        }
    }
    dp[v].first = ans1;
    dp[v].second = ans2;
}

int main(){
    int n;
    cin >> n;
    vector<vector<int> > g(n);
    for (int v = 0; v < n; ++v){
        int u;
        cin >> u;

        if (u != -1){
            --u;
            g[v].push_back(u);
            g[u].push_back(v);
        }
    }
    if (n <= 20){
        int ans = 0;
        for (int mask = 0; mask < (1 << n); ++mask){
            if (check(g, mask)){
                ans = max(ans, f(mask));
            }
        }
        cout << ans << endl;
    }
    else{
        vector<char> used(n);
        vector<pair<int, int> > dp(n);
        int ans = 0;
        for (int v = 0; v < n; ++v){
            if (!used[v]){
                dfs(g, used, dp, v);
                ans += max(dp[v].first, dp[v].second);
            }
        }
        cout << ans << endl;
    }

    return 0;
}
