#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define all(v) v.begin(), v.end()

int revMask(int mask, int k){
    int ans = 0;
    for (int i = 0; i < k; ++i){
        if (!(mask & (1 << i))){
            ans |= (1 << i);
        }
    }
    return ans;
}

bool dfs(vector<vector<int> > &rightPart, vector<vector<int> > &leftPart, vector<char> &used, vector<int> &match, int v){
    //cout << v << endl;
    used[v] = true;
    for (int i = 0; i < rightPart[v].size(); ++i){
        int u = rightPart[v][i];
        if (!used[u] || match[u] == -1 || (!used[match[u]] && dfs(rightPart, leftPart, used, match, match[u]))){
            used[u] = true;
            match[u] = v;
            return true;
        }
    }
    return false;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, k;
    cin >> n >> k;
    vector<pair<vector<int>, int> > arr(n, make_pair(vector<int>(k), 0));
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < k; ++j){
            cin >> arr[i].first[j];
        }
        arr[i].second = i + 1;
    }
    if (k == 1){
        sort(all(arr));
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; ++i){
            cout << arr[i].second << " " << arr[i + n / 2].second << endl;
        }
    }
    else if (n > 10){
        vector<int> b(k);
        for (int i = 0; i < k; ++i){
            vector<int> tmp(n);
            for (int j = 0; j < n; ++j){
                tmp[j] = arr[j].first[i];
            }
            sort(all(tmp));
            b[i] = tmp[n / 2];
        }
        vector<vector<pair<vector<int>, int> > > a(1 << k);
        for (int i = 0; i < n; ++i){
            int mask = 0;
            for (int j = 0; j < k; ++j){
                if (arr[i].first[j] >= b[j]){
                    mask = (mask | (1 << j));
                }
            }
            a[mask].push_back(arr[i]);
        }
        vector<pair<int, int> > ans;
        for (int mask = 0; mask < (1 << k - 1); ++mask){
            int rMask = revMask(mask, k);
            if (a[mask].size() != a[rMask].size()){
                cout << "NO" << endl;
                return 0;
            }
            for (int i = 0; i < a[mask].size(); ++i){
                ans.push_back(make_pair(a[mask][i].second, a[rMask][i].second));
            }
        }
        cout << "YES" << endl;
        for (int i = 0; i < ans.size(); ++i){
            cout << ans[i].first << " " << ans[i].second << endl;
        }
    }
    else{
        vector<int> b(k);
        for (int i = 0; i < k; ++i){
            vector<int> tmp(n);
            for (int j = 0; j < n; ++j){
                tmp[j] = arr[j].first[i];
            }
            sort(all(tmp));
            b[i] = tmp[n / 2];
        }
        vector<int> m(n);
        for (int i = 0; i < n; ++i){
            int mask = 0;
            for (int j = 0; j < k; ++j){
                if (arr[i].first[j] >= b[j]){
                    mask |= (1 << j);
                }
            }
            m[i]=  mask;
        }
        vector<vector<int> > rightPart(n), leftPart(n);
        cout << endl;
        for (int i = 0; i < n; ++i){
            for (int j = 0; j < n; ++j){
                if (m[i] == revMask(m[j], k) && m[i] >= (1 << k - 1)){
                    rightPart[i].push_back(j);
                    leftPart[j].push_back(i);
                }
            }
        }
        vector<char> used(n);
        vector<int> match(n, -1);
        for (int v = 0; v < n; ++v){
            if (m[v] >= (1 << k - 1) && !used[v]){
                dfs(rightPart, leftPart, used, match, v);
                /*for (int i = 0; i < n; ++i){
                    cout << match[i] << " ";
                }
                cout << endl;*/
            }
        }
        vector<pair<int, int> > ans;
        for (int v = 0; v < n; ++v){
            if (match[v] != -1){
                ans.push_back(make_pair(v, match[v]));
            }
        }
        if (ans.size() != n / 2){
            cout << "NO" << endl;
        }
        else{
            cout << "YES" << endl;
            for (int i = 0; i < n / 2; ++i){
                cout << ans[i].first + 1 << " " << ans[i].second + 1 << endl;
            }
        }
    }
    return 0;
}
/*
6 2
8 6
1 5
6 3
3 1
4 7
7 2
*/
/*
4 3
1 -1 -1
2 1 1
3 -1 1
4 1 -1
*/
